//
//  ViewController.m
//  HandwrittenChartAnnotations
//
//  Created by kelley.ricker on 6/2/16.
//  Copyright © 2016 GrapeCity. All rights reserved.
//

#import "ViewController.h"
#import "ChartData.h"
#import "ImageAnnotateController.h"
#import <XuniFlexChartKit/XuniFlexChartKit.h>

@interface ViewController (){
    UIButton *annotateButton;
    UIImageView *imageView;
    FlexChart *chart;
}

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    self.edgesForExtendedLayout = UIRectEdgeNone;
    self.title = @"Handwritten Annotations";
    
    chart = [[FlexChart alloc] init];
    imageView = [[UIImageView alloc] init];
    NSMutableArray *chartData = [ChartData demoData];
    chart.bindingX = @"name";
    XuniSeries *sales = [[XuniSeries alloc] initForChart:chart binding:@"sales, sales" name:@"Sales"];
    XuniSeries *expenses = [[XuniSeries alloc] initForChart:chart binding:@"expenses, expenses" name:@"Expenses"];
    XuniSeries *downloads = [[XuniSeries alloc] initForChart:chart binding:@"downloads, downloads" name:@"Downloads"];
    
    annotateButton = [UIButton buttonWithType:UIButtonTypeSystem];
    [annotateButton setTitle:@"Annotate!" forState:UIControlStateNormal];
    [annotateButton addTarget:self action:@selector(annotateButtonClicked) forControlEvents:UIControlEventTouchUpInside];
    
    [chart.series addObject:sales];
    [chart.series addObject:expenses];
    [chart.series addObject:downloads];
    chart.itemsSource = chartData;
    chart.frame = self.view.frame;
    [self.view addSubview:chart];
    [self.view addSubview:annotateButton];

}

-(void)viewDidLayoutSubviews{;
    chart.frame = CGRectMake(0, 0, self.view.bounds.size.width , self.view.bounds.size.height - 35);
    annotateButton.frame = CGRectMake(0, self.view.bounds.size.height - 30, self.view.bounds.size.width, 25);
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void)annotateButtonClicked{
    ImageAnnotateController *imageAnnnotateController = [[ImageAnnotateController alloc] init];
    imageAnnnotateController.chartImage = [UIImage imageWithData:[chart getImage]];
    [self.navigationController pushViewController:imageAnnnotateController animated:true];
}
@end
